#include <stdio.h>
#include <pthread.h>
#include <sys/syscall.h>

#define gettid() syscall(__NR_gettid)
#define NUMBER_OF_THREADS	70

int my_test_func(unsigned int num)
{
	unsigned int i=0; 
	unsigned int total=0;
	for(i=0; i<num; i++)
		total += i;
	return total;
}

void * thread(void * arg)
{
	while(1)
	{
		printf("I am pthread %d.\n", gettid());
		
		if( (unsigned int)arg == NUMBER_OF_THREADS )
		{
			my_test_func(100);
			sleep(5);
		}
		else
		{
			sleep((unsigned int)arg * 30);
		}
	}
}

int main(void)
{
	pthread_t id;
	int i,ret;
	for( i=1; i<=NUMBER_OF_THREADS; i++)
	{
		ret=pthread_create(&id,NULL,(void *)thread,(void*)(i));
		if(ret!=0){
			printf ("Create pthread error!\n");
			return -1;
		}
	}

	printf("This is the main process %d.\n", gettid());
	pthread_join(id,NULL);
	return (0);
}

